#include<Servo.h>

// Erstelle Motorobjekte für die verbauten Servomotoren
Servo FLIPPER_LEFT;
Servo FLIPPER_RIGHT;


// Pinverteilung
int LEFTARM_PIN = 4;
int RIGHTARM_PIN = 8;
int LEFTBUTTON_PIN = 5;
int RIGHTBUTTON_PIN = 6;
int FLIPPER_STOP_PIN = A2;
int FLIPPER_SWITCH_PIN = A3;

void setup() {

  // Motoren wird Pin zugewiesen
  FLIPPER_LEFT.attach(LEFTARM_PIN);
  FLIPPER_RIGHT.attach(RIGHTARM_PIN);

  // Output und INPUT Zuweisung der einzelnen PINs
  pinMode(RIGHTARM_PIN, OUTPUT);
  pinMode(LEFTARM_PIN, OUTPUT);
  pinMode(LEFTBUTTON_PIN, INPUT);
  pinMode(RIGHTBUTTON_PIN, INPUT);
  pinMode(FLIPPER_STOP_PIN, INPUT);
  pinMode(FLIPPER_SWITCH_PIN, INPUT);
}

void loop() {

  /* falls der Arduino Nano vom Arduino Mega ein Signal zum Blockieren der Flipperarme bekommt,
     werden die Arme blockiert.
  */
  if (analogRead(FLIPPER_STOP_PIN) >900){
    blockFlipperarms();
   
    /* falls der Arduino Nano vom Arduino Mega ein Signal zum Vertauschen der Flipperarme bekommt,
       werden die Arme vertauscht.
    */
  } else if (analogRead(FLIPPER_SWITCH_PIN) >900){
    switchFlipperarms();
  }

  /* wenn der rechte Taster gedrückt wird, wird der rechte Arm noch oben bewegt,
     oder oben gehalten, falls er bereits in dieser Position ist.
     Andernfalls wird er zurück in seine Ausgangsposition gebracht.
   */
  if (digitalRead(LEFTBUTTON_PIN) == HIGH) {
    FLIPPER_LEFT.write(65);                 // Flipperarm nach oben
  } else {
    FLIPPER_LEFT.write(92);                 // Flipperarm in Ausgangsposition
  }

  /* wenn der linke Taster gedrückt wird, wird der linke Arm noch oben bewegt,
     oder oben gehalten, falls er bereits in dieser Position ist.
     Andernfalls wird er zurück in seine Ausgangsposition gebracht.
   */
  if (digitalRead(RIGHTBUTTON_PIN) == HIGH) {
    FLIPPER_RIGHT.write(95);                // Flipperamr nach oben
  } else {
    FLIPPER_RIGHT.write(75);                // Flipperarm in Ausgangsposition
  }

}


// Funktion zum Vertauschen der Flipperarme
void switchFlipperarms() {
  int temp = RIGHTARM_PIN;                // Hilfsvariable zum Zwischenspeichern des RIGHTARM_PIN- Wertes
  RIGHTARM_PIN = LEFTARM_PIN;
  LEFTARM_PIN = RIGHTARM_PIN;
}

// Funktion zum Blockieren der Flipperarme
void blockFlipperarms() {
  delay(5000);
}
